%% Ej 4 TP 2  -  SyS 2017

%// Autor: SR
%// Clculo de las salidas del sistema continuo del Ej 4 mediante la 
%// funcin 'conv' y comparacin con el clculo analtico de cada una.

% Necesita en la misma carpeta las funciones 'plot_SR_subplot'.

clear all; close all; clc;

%% i) con x1

dt = 0.001;         % Paso de tiempo para aproximar 'lo continuo'
t = -2:dt:10;       % Vector de tiempo
t_conv = -4:dt:20;  % Vector de tiempo de la convolucion. Recordar que el 
                    % soporte de la convolucin es la suma de los soportes 
                    % cada seal a convolucionar.

h2 = 12/5.*exp(-2.*t).*(t >= 0); % Rta. impulsional sistema continuo.
x1 = 5/2.*(t >= 0);              % Primer entrada x1(t)

y1 = conv(x1,h2)*dt;             % No olvidar multiplicar por el paso dt.
y1_anal = 3.*(1-exp(-2.*t)).*(t >= 0); % Clculo del papel.

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

p1 = plot_SR_subplot([t_conv(1) t_conv(end) 0 4],'t','$y_1(t)$','Convolucion entre $x_1(t)$ y $h(t)$',20,'b',t_conv,y1);
p1.LineWidth = 1.5; % En versiones de Matlab anteriores a 2014 puede que no funcione esta manera de cambiar el grosor de la linea.
hold on;
p2 = plot_SR_subplot([t(1) t(end) 0 4],'t','$y(t)$','Convolucion entre $x_1(t)$ y $h(t)$',20,'r--',t,y1_anal);
p2.LineWidth = 3;
legend('Aproximacion','Papel');

%% Realice lo mismo para las dems entradas. Compare luego con 
%  el cdigo que se encuentra en la parte inferior de este script.

%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%






%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%

%% ii) con x2

dt = 0.001;
t = -2:dt:10;
t_conv = -4:dt:20;

h2 = 12/5.*exp(-2.*t).*(t >= 0);
x2 = 3/2.*(t >= 0)+1/2.*(t>=5/2);

y2 = conv(x2,h2)*dt;
y2_anal = 3/5.*3.*(1-exp(-2.*t)).*(t >= 0) + 1/5.*3.*(1-exp(-2.*(t-5/2))).*((t-5/2) >= 0);

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

p1 = plot_SR_subplot([t_conv(1) t_conv(end) 0 4],'t','$y_2(t)$','Convolucion entre $x_2(t)$ y $h(t)$',20,'b',t_conv,y2);
p1.LineWidth = 1.5;
hold on;
p2 = plot_SR_subplot([t(1) t(end) 0 3],'t','$y(t)$','Convolucion entre $x_2(t)$ y $h(t)$',20,'r--',t,y2_anal);
p2.LineWidth = 3;
legend('Aproximacion','Papel');

%% iii) con x3

dt = 0.001;
t = -2:dt:10;
t_conv = -4:dt:20;

h2 = 12/5.*exp(-2.*t).*(t >= 0);
x3 = 3/2.*((t >= 0) & (t <= 3));

y3 = conv(x3,h2)*dt;
y3_anal = 3/5.*3.*(1-exp(-2.*t)).*(t >= 0) - 3/5.*3.*(1-exp(-2.*(t-3))).*((t-3) >= 0);

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

p1 = plot_SR_subplot([t_conv(1) t_conv(end) 0 4],'t','$y_3(t)$','Convolucion entre $x_3(t)$ y $h(t)$',20,'b',t_conv,y3);
p1.LineWidth = 1.5;
hold on;
p2 = plot_SR_subplot([t(1) t(end) 0 2],'t','$y_3(t)$','Convolucion entre $x_3(t)$ y $h(t)$',20,'r--',t,y3_anal);
p2.LineWidth = 3;
legend('Aproximacion','Papel');

%% iii) con x4

dt = 0.001;
t = -2:dt:10;
t_conv = -4:dt:20;

h2 = 12/5.*exp(-2.*t).*(t >= 0);
x4 = t.*(t >= 0);

y4 = conv(x4,h2)*dt;
y4_anal = 6/5.*(t-1/2+1/2.*exp(-2.*t));

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

p1 = plot_SR_subplot([0 t_conv(end) 0 15],'t','$y_4(t)$','Convolucion entre $x_4(t)$ y $h(t)$',20,'b',t_conv,y4);
p1.LineWidth = 1.5;
hold on;
p2 = plot_SR_subplot([0 t(end) 0 15],'t','$y_4(t)$','Convolucion entre $x_4(t)$ y $h(t)$',20,'r--',t,y4_anal);
p2.LineWidth = 3;
legend('Aproximacion','Papel');

%% Repita este script con los cambios adecuados para el sistema discreto 
%  del ejercicio 4.

%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%






%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%