%% Ej 8 TP 3  -  SyS 2017

clear all;close all;clc

%// Autor: SR
%// Analizar algunas situaciones del filtro promedio movil.

%% c) Salida del sistema si entra A + sen(2*pi*n/M) con M = 7 (por ejemplo)

A = 1.5;
N = 3;
M = 2*N+1;
so = 1/M;

n = -100:100;

x = A + sin(2*pi*n*so);
y = filter(ones(1,M)*1/M,1,x); % Notar que el promedio movil es un FIR de 
                               % M coeficientes donde cada uno vale 1/M. 
                               % O sea que b = ones(1,M)*1/M; y a = 1. 
                               % 'help filter' para ver que son 'a' y 'b'.

figure('units','normalized','outerposition',[0 0 1 1])
subplot(2,1,1);
stem(n,x,'filled');
set(gca, 'FontSize', 18);
legend('Entrada x[n]','Location', 'Southwest');grid on;
xlabel('n','Interpreter','Latex','FontSize',20);
axis([0 length(n)/2 min(x)-0.5 max(x)+0.5]);

subplot(2,1,2);
stem(n,y,'filled');
set(gca, 'FontSize', 18);
legend('Salida y[n] (M = 7)','Location','NorthWest');grid on;
xlabel('n','Interpreter','Latex','FontSize',20);
axis([0 length(n)/2 0 max(y) + 0.5]);

% Probar con distintos valores de s0. Por ejemplo, k/M con k entero. Ver la
% salida. Ahora pruebe por ejemplo con s0 = 1.1/M . Mire la salida. 


%% d) Proceso X = A + V como entrada y 3 salidas para =! M.

clear all;clc;close all

N = [1 3 6];
M = 2*N+1;  % M = 3, M = 7 y M = 13
A = 1;
Var = 1;
V = randn(1,1e5)*sqrt(Var);
X = A + V;

for i=1:length(N)
    Y(i,:) = filter(ones(1,M(i))*1/M(i),1,X);
end

figure('units','normalized','outerposition',[0 0 1 1])
plot(X,'r'); hold on;
plot(Y(1,:),'g','linewidth',2);hold on;
plot(Y(2,:),'b','linewidth',2);hold on;
plot(Y(3,:),'m','linewidth',2);hold on;
set(gca, 'FontSize', 18);
legend(['Entrada X[n], var: ' num2str(var(X))],['Salida Y[n] M = 3, var: ' num2str(var(Y(1,:)))],['Salida Y[n] M = 7, var: ' num2str(var(Y(2,:)))],['Salida Y[n] M = 13, var: ' num2str(var(Y(3,:)))],'Location', 'Southwest');grid on;
xlabel('n','Interpreter','Latex','FontSize',20);
xlim([0 400])


%% d) i) Autocorrelacion de X = A + V.

clear all;clc;close all

N_Real = 500;   % Numero de realizaciones
N = 500;        % Largo del vector X.
A = 1;
Var = 1;

V = randn(N_Real,N)*sqrt(Var); 
X = A + V;

m_max=10;       % Para m entre -10 y 10.
for m = -m_max:m_max
    n = (1+m_max):(N-m_max);
    pX = X(:,n+m).*X(:,n);
    rX = mean(pX,1);
    RX(1+m_max+m)=mean(rX);
end

figure('units','normalized','outerposition',[0 0 1 1]);
stem(-m_max:m_max,RX,'filled');
set(gca, 'FontSize', 18);
legend('R_{XX} [m]', 'Location', 'Northwest');grid on;
xlabel('m','Interpreter','Latex','FontSize',20);
axis([-10 10 0 2.5]);

Media_est = mean(mean(X,1));                    % Media aproximada
Varianza_est = RX(m_max+1) - Media_est^2;       % Varianza aproximada

%% d) ii) y iii) Autocorrelacion de Y

clear all;clc;close all;close all

N_Real = 500;   % Numero de realizaciones
N = 500;        % Largo del vector X.
A = 1;
Var = 1;
M = 3;

V = randn(N_Real,N)*sqrt(Var); 
X = A + V;
Y = filter(ones(1,M)*1/M,1,X);

m_max=10;
for m = -m_max:m_max
    n = (1+m_max):(N-m_max);
    pY = Y(n+m,:).*Y(n,:);
    rY = mean(pY,1);
    RY(1+m_max+m)=mean(rY);
end

figure('units','normalized','outerposition',[0 0 1 1]);
stem(-m_max:m_max,RY,'filled');
set(gca, 'FontSize', 18);
legend(['R_{YY} [m]. Var\{Y[n]\} aprox = ' num2str(max(RY)-1)], 'Location', 'Northwest');grid on;
xlabel('m','Interpreter','Latex','FontSize',20);
axis([-10 10 0 2]);

% Notar que la varianza de la salida es Var{X}/M .
